unit PionManager;

interface

uses Graphics,ExtCtrls,classes,SysUtils,Forms,controls;

type

TPion = class
private
  FTop:integer;
  FLeft:integer;
    Fvisible: boolean;
    FLigne: integer;
    FColonne: integer;
    procedure MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure SetColonne(const Value: integer);
    procedure SetLigne(const Value: integer);
    procedure Setvisible(const Value: boolean);
    procedure SetLeft(const Value: integer);
    procedure SetTop(const Value: integer);
public
  Joueur:integer;
  EnMouvement:boolean;
  Image:Timage;

  destructor free;
  Procedure Init(AOwner:Tcomponent;J:integer);
  Property Top:integer read FTop write SetTop;
  Property Left:integer read FLeft write SetLeft;
  Property visible:boolean read Fvisible write Setvisible;
  Property Ligne:integer read FLigne write SetLigne;
  Property Colonne:integer read FColonne write SetColonne;
end;


implementation



{ TPion }

destructor TPion.free;
begin
  freeandnil(Image);
end;

Procedure TPion.Init(AOwner:Tcomponent;J:integer);
begin
  Joueur:=J;
  EnMouvement:=true;
  Image:=TImage.Create(AOwner);
  Image.Parent:=TForm(AOwner);
  Image.Transparent:=true;
  visible:=false;
  if J=1  then
    Image.Picture.LoadFromFile(extractfilepath(application.exename)+'images\Pion rouge.bmp')
  else if J=2 then
    Image.Picture.LoadFromFile(extractfilepath(application.exename)+'images\Pion jaune.bmp')
  else if J=3 then
    Image.Picture.LoadFromFile(extractfilepath(application.exename)+'images\Pion bi.bmp');
  Image.OnClick:=Tform(AOwner).OnClick;
  Image.OnMouseMove:=MouseMove;
end;


procedure TPion.MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin   //retransmet le mouvement de la souri sur le pion au plateau
   Tform(Image.parent).OnMouseMove(Sender,Shift, X+Image.Left,Y+Image.top);
end;


procedure TPion.SetColonne(const Value: integer);
begin
  FColonne := Value;
  Left:=134+38+70*(Value-1)-23
end;

procedure TPion.SetLeft(const Value: integer);
begin
  FLeft := Value;
  Image.Left:=FLeft;
end;

procedure TPion.SetLigne(const Value: integer);
begin
  FLigne := Value;
  Top:=134+38+70*(Value-1)-23;
end;

procedure TPion.SetTop(const Value: integer);
begin
  FTop := Value;
  Image.Top:=FTop;
end;

procedure TPion.Setvisible(const Value: boolean);
begin
  Fvisible := Value;
  Image.visible:=Fvisible;
end;

end.
